/*
 * forum.c
 *
 *  Created on: 20 de mar de 2017
 *      Author: Alexandre
 */

#include "forum.h"

#define boolean int

Tuple dirs[6];

Tuple tree;

int level;

int count;

int BUF = 28000;
int *lxi, *lyi, *lzi, *lxf, *lyf, *lzf;
DWORD *colors;
int idx;

DWORD pallete[] = {
	0,
	0x00ff0000,
	0x00ffff00,
	0x0000ff00,
	0x00ff00ff,
	0x00ffaaaa,
	0x00ff3f35,
	0x00bd8d7e,
	0x00ffbf00,
};

int sgn(int n)
{
	if(n > 0)
		return 1;
	else if(n < 0)
		return -1;
	return 0;
}

void delay(unsigned int mseconds)
{
    clock_t goal = mseconds + clock();
    while (goal > clock());
}

void deleteObjects()
{
	free(colors);
	free(lxi);
	free(lyi);
	free(lzi);
	free(lxf);
	free(lyf);
	free(lzf);

}

/*
 * von Neumann directions
 */
void initDirs()
{
	dirs[0].x = 1;
	dirs[0].y = 0;
	dirs[0].z = 0;
	//
	dirs[1].x = -1;
	dirs[1].y = 0;
	dirs[1].z = 0;
	//
	dirs[2].x = 0;
	dirs[2].y = 1;
	dirs[2].z = 0;
	//
	dirs[3].x = 0;
	dirs[3].y = -1;
	dirs[3].z = 0;
	//
	dirs[4].x = 0;
	dirs[4].y = 0;
	dirs[4].z = 1;
	//
	dirs[5].x = 0;
	dirs[5].y = 0;
	dirs[5].z = -1;
}

boolean isAllowed(int dir)
{
	// Expansion algorithm
	//
	int s0 = (tree.x * tree.y < 0) ? 1 : 0;
	int s1 = (tree.y * tree.z < 0) ? 1 : 0;
	int s2 = (tree.z * tree.x < 0) ? 1 : 0;
	//
	int sx = sgn(tree.x);
	int sy = sgn(tree.y);
	int sz = sgn(tree.z);
	//
	if(tree.x != 0)
	{
		if(tree.y != 0)
		{
			if(tree.z != 0)
			{
				// 3d spiral
				//
				switch(level % 3)
				{
					case 0:
						if(sx < 0)
						{
							if(dir == 1) return true;
						}
						else
						{
							if(dir == 0) return true;
						}
						break;
					case 1:
						if(sy < 0)
						{
							if(dir == 3) return true;
						}
						else
						{
							if(dir == 2) return true;
						}
						break;
					case 2:
						if(sz < 0)
						{
							if(dir == 5) return true;
						}
						else
						{
							if(dir == 4) return true;
						}
						break;
				}
			}
			else
			{
				// xy plane
				//
				if(level % 2 == s0)
				{
					if(sx < 0)
					{
						if(dir == 1) return true;
					}
					else
					{
						if(dir == 0) return true;
					}
				}
				else
				{
					if(sy < 0)
					{
						if(dir == 3) return true;
					}
					else
					{
						if(dir == 2) return true;
					}
				}
				//
				if(level % 3 == 0 && dir > 3)
					return true;
			}
		}
		else if(tree.z != 0)
		{
			// zx plane
			//
			if(level % 2 == s2)
			{
				if(sz < 0)
				{
					if(dir == 5) return true;
				}
				else
				{
					if(dir == 4) return true;
				}
			}
			else
			{
				if(sx < 0)
				{
					if(dir == 1) return true;
				}
				else
				{
					if(dir == 0) return true;
				}
			}
			//
			if(level % 3 == 2 && (dir == 2 || dir == 3))
				return true;
		}
		else
		{
			// x axis
			//
			if(sx < 0)
			{
				if(dir == 1) return true;
			}
			else
			{
				if(dir == 0) return true;
			}
			//
			if(level % 2 == 0)
			{
				if(sx < 0)
				{
					if(dir == 2) return true;
				}
				else
				{
					if(dir == 3) return true;
				}
				//
				if(sx < 0)
				{
					if(dir == 5) return true;
				}
				else
				{
					if(dir == 4) return true;
				}
			}
			else
			{
				if(sx < 0)
				{
					if(dir == 3) return true;
				}
				else
				{
					if(dir == 2) return true;
				}
				//
				if(sx < 0)
				{
					if(dir == 4) return true;
				}
				else
				{
					if(dir == 5) return true;
				}
			}
		}
	}
	else if(tree.y != 0)
	{
		if(tree.z != 0)
		{
			// yz plane
			//
			if(level % 2 == s1)
			{
				if(sy < 0)
				{
					if(dir == 3) return true;
				}
				else
				{
					if(dir == 2) return true;
				}
			}
			else
			{
				if(sz < 0)
				{
					if(dir == 5) return true;
				}
				else
				{
					if(dir == 4) return true;
				}
			}
			//
			if(level % 3 == 1 && dir < 2)
				return true;
		}
		else
		{
			// y axis
			//
			if(sy < 0)
			{
				if(dir == 3) return true;
			}
			else
			{
				if(dir == 2) return true;
			}
			//
			if(level % 2 == 0)
			{
				if(sy < 0)
				{
					if(dir == 1) return true;
				}
				else
				{
					if(dir == 0) return true;
				}
				//
				if(sy < 0)
				{
					if(dir == 4) return true;
				}
				else
				{
					if(dir == 5) return true;
				}
			}
			else
			{
				if(sy < 0)
				{
					if(dir == 0) return true;
				}
				else
				{
					if(dir == 1) return true;
				}
				//
				if(sy < 0)
				{
					if(dir == 5) return true;
				}
				else
				{
					if(dir == 4) return true;
				}
			}
		}
	}
	else if(tree.z != 0)
	{
		// z axis
		//
		if(sz < 0)
		{
			if(dir == 5) return true;
		}
		else
		{
			if(dir == 4) return true;
		}
		//
		if(level % 2 == 0)
		{
			if(sz < 0)
			{
				if(dir == 0) return true;
			}
			else
			{
				if(dir == 1) return true;
			}
			//
			if(sz < 0)
			{
				if(dir == 3) return true;
			}
			else
			{
				if(dir == 2) return true;
			}
		}
		else
		{
			if(sz < 0)
			{
				if(dir == 1) return true;
			}
			else
			{
				if(dir == 0) return true;
			}
			//
			if(sz < 0)
			{
				if(dir == 2) return true;
			}
			else
			{
				if(dir == 3) return true;
			}
		}
	}
	else
	{
		// Root
		//
		return true;
	}
	return false;
}

int getType(int dir)
{
	int s0 = (tree.x * tree.y < 0) ? 1 : 0;
	int s1 = (tree.y * tree.z < 0) ? 1 : 0;
	int s2 = (tree.z * tree.x < 0) ? 1 : 0;
	//
	int sx = sgn(tree.x);
	int sy = sgn(tree.y);
	int sz = sgn(tree.z);
	//
	if(tree.x != 0)
	{
		if(tree.y != 0)
		{
			if(tree.z != 0)
			{
				// 3d spiral (8)
				//
				switch(level % 3)
				{
					case 0:
						if(sx < 0)
						{
							if(dir == 1) return 8;
						}
						else
						{
							if(dir == 0) return 8;
						}
						break;
					case 1:
						if(sy < 0)
						{
							if(dir == 3) return 8;
						}
						else
						{
							if(dir == 2) return 8;
						}
						break;
					case 2:
						if(sz < 0)
						{
							if(dir == 5) return 8;
						}
						else
						{
							if(dir == 4) return 8;
						}
						break;
				}
			}
			else
			{
				// xy plane (5)
				//
				if(level % 2 == s0)
				{
					if(sx < 0)
					{
						if(dir == 1) return 5;
					}
					else
					{
						if(dir == 0) return 5;
					}
				}
				else
				{
					if(sy < 0)
					{
						if(dir == 3) return 5;
					}
					else
					{
						if(dir == 2) return 5;
					}
				}
				//
				if(level % 3 == 0 && (dir == 4 || dir == 5))
					return 5;
			}
		}
		else if(tree.z != 0)
		{
			// zx plane (7)
			//
			if(level % 2 == s2)
			{
				if(sz < 0)
				{
					if(dir == 5) return 7;
				}
				else
				{
					if(dir == 4) return 7;
				}
			}
			else
			{
				if(sx < 0)
				{
					if(dir == 1) return 7;
				}
				else
				{
					if(dir == 0) return 7;
				}
			}
			//
			if(level % 3 == 2 && (dir == 2 || dir == 3))
				return 7;
		}
		else
		{
			// x axis (2)
			//
			if(sx < 0)
			{
				if(dir == 1) return 2;
			}
			else
			{
				if(dir == 0) return 2;
			}
			//
			if(level % 2 == 0)
			{
				if(sx < 0)
				{
					if(dir == 2) return 2;
				}
				else
				{
					if(dir == 3) return 2;
				}
				//
				if(sx < 0)
				{
					if(dir == 5) return 2;
				}
				else
				{
					if(dir == 4) return 2;
				}
			}
			else
			{
				if(sx < 0)
				{
					if(dir == 3) return 2;
				}
				else
				{
					if(dir == 2) return 2;
				}
				//
				if(sx < 0)
				{
					if(dir == 4) return 2;
				}
				else
				{
					if(dir == 5) return 2;
				}
			}
		}
	}
	else if(tree.y != 0)
	{
		if(tree.z != 0)
		{
			// yz plane (6)
			//
			if(level % 2 == s1)
			{
				if(sy < 0)
				{
					if(dir == 3) return 6;
				}
				else
				{
					if(dir == 2) return 6;
				}
			}
			else
			{
				if(sz < 0)
				{
					if(dir == 5) return 6;
				}
				else
				{
					if(dir == 4) return 6;
				}
			}
			//
			if(level % 3 == 1 && dir < 2)
				return 6;
		}
		else
		{
			// y axis (3)
			//
			if(sy < 0)
			{
				if(dir == 3) return 3;
			}
			else
			{
				if(dir == 2) return 3;
			}
			//
			if(level % 2 == 0)
			{
				if(sy < 0)
				{
					if(dir == 1) return 3;
				}
				else
				{
					if(dir == 0) return 3;
				}
				//
				if(sy < 0)
				{
					if(dir == 4) return 3;
				}
				else
				{
					if(dir == 5) return 3;
				}
			}
			else
			{
				if(sy < 0)
				{
					if(dir == 0) return 3;
				}
				else
				{
					if(dir == 1) return 3;
				}
				//
				if(sy < 0)
				{
					if(dir == 5) return 3;
				}
				else
				{
					if(dir == 4) return 3;
				}
			}
		}
	}
	else if(tree.z != 0)
	{
		// z axis (4)
		//
		if(sz < 0)
		{
			if(dir == 5) return 4;
		}
		else
		{
			if(dir == 4) return 4;
		}
		//
		if(level % 2 == 0)
		{
			if(sz < 0)
			{
				if(dir == 0) return 4;
			}
			else
			{
				if(dir == 1) return 4;
			}
			//
			if(sz < 0)
			{
				if(dir == 3) return 4;
			}
			else
			{
				if(dir == 2) return 4;
			}
		}
		else
		{
			if(sz < 0)
			{
				if(dir == 1) return 4;
			}
			else
			{
				if(dir == 0) return 4;
			}
			//
			if(sz < 0)
			{
				if(dir == 2) return 4;
			}
			else
			{
				if(dir == 3) return 4;
			}
		}
	}
	else
	{
		// Root (1)
		//
		return 1;
	}
	return 0;
}

void spaces()
{
	printf("   ");
	int i;
	for(i = 0; i < level; i++)
		printf("   ");
}

Tuple last;

void expandTree()
{
	int i;
	for(i = 0; i < 6; i++)
	{
		int type = getType(i);
		if(isAllowed(i))
		{
			last.x = tree.x;
			last.y = tree.y;
			last.z = tree.z;
			//
			tree.x += dirs[i].x;
			tree.y += dirs[i].y;
			tree.z += dirs[i].z;
			//
			if(abs(tree.x) == n / 2 + 1 || abs(tree.y) == n / 2 + 1 || abs(tree.z) == n / 2 + 1)
			{
				tree.x -= dirs[i].x;
				tree.y -= dirs[i].y;
				tree.z -= dirs[i].z;
				continue;
			}
			else
			{
				count++;
				if(types[type] && (!quadrant || (tree.x >= 0 && tree.y >= 0 && tree.z >= 0)))
				{
					colors[idx] = pallete[type];
					lxi[idx] = last.x;
					lyi[idx] = last.y;
					lzi[idx] = last.z;
					lxf[idx] = tree.x;
					lyf[idx] = tree.y;
					lzf[idx] = tree.z;
					idx++;
				}
				//
				level++;
				expandTree();
				level--;
				//
				tree.x -= dirs[i].x;
				tree.y -= dirs[i].y;
				tree.z -= dirs[i].z;
			}
		}
	}
}

void drawPoint(int x, int y, int z)
{
	colors[idx] = 0x00ffffff;
	lxi[idx] = x;
	lyi[idx] = y;
	lzi[idx] = z;
	lxf[idx] = x;
	lyf[idx] = y;
	lzf[idx] = z;
	idx++;
}

void drawCircles()
{
	int x, y, z;
	for(x = 0; x < n; x++)
		for(y = 0; y < n; y++)
			for(z = 0; z < n; z++)
				if(!quadrant || (x >= n/2 && y >= n/2 && z >= n/2))
					drawPoint(x-(n/2), y-(n/2), z-(n/2));
}

boolean prime = true;

void generateTree()
{
	if(prime)
	{
		colors = malloc(BUF*sizeof(DWORD));
		lxi = malloc(BUF);
		lyi = malloc(BUF);
		lzi = malloc(BUF);
		lxf = malloc(BUF);
		lyf = malloc(BUF);
		lzf = malloc(BUF);
		initDirs();
		prime = false;
	}
	char *title;
 	asprintf(&title, "Tree %dx%dx%d", n, n, n);
 	SetWindowText(GetActiveWindow(), title);
	idx = 0;
	//
	tree.x = 0;
	tree.y = 0;
	tree.z = 0;
	//
	level = 0;
	//
	expandTree();
	drawCircles();
}

